#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jun 20 22:29:53 2022

@author: ajuton
"""

import tkinter #module gérant l'affichage

class fenetre_apprentissage :
    #fonctions associées aux boutons
    def demarrer(self):
        self.bouton_start = 1
               
    def fonction_mode_manuel(self):
        print(self.mode_manuel)
        if self.mode_manuel==0 :
            #on passe en mode manuel, les boutons passent en rouge
            self.mode_manuel = 1
            self.bouton2.configure(bg="red")
            self.bouton2.configure(activebackground="salmon")
            self.bouton3.configure(bg="red")
            self.bouton3.configure(activebackground="salmon")
        else:
            #on repasse en mode auto, les boutons reprennent la couleur d'origine
            self.mode_manuel = 0
            self.bouton2.configure(bg='#d9d9d9')
            self.bouton2.configure(activebackground='#ececec')
            self.bouton3.configure(bg='#d9d9d9')
            self.bouton3.configure(activebackground='#ececec')
            
    
    def mouvement_suivant(self):
        self.pas_suivant = 1
        
    def __init__(self):
        #Création de la fenêtre de paramètres
        self.bouton_start=0
        self.mode_manuel=0
        self.pas_suivant=0
        self.fenetre = tkinter.Tk()
        self.fenetre.title("Frozen Lake")
        cadre =tkinter.LabelFrame(self.fenetre,bg ="gray85",border =3, relief =tkinter.GROOVE,text="Contrôles", width = 500)
        cadre.grid(row=0, column=0)
        self.bouton0 = tkinter.Button(cadre, text ="Quitter", command =self.fenetre.destroy)
        self.bouton0.pack(side =tkinter.LEFT)
        self.bouton1 = tkinter.Button(cadre, text ="Demarrer / Nouvel épisode", command =self.demarrer)
        self.bouton1.pack(side =tkinter.LEFT)
        self.bouton2 = tkinter.Button(cadre, text ="Mode_manuel", command = self.fonction_mode_manuel)
        self.bouton2.pack(side =tkinter.LEFT)
        self.bouton3 = tkinter.Button(cadre, text ="Mouvement_suivant", command = self.mouvement_suivant)
        self.bouton3.pack(side =tkinter.LEFT)

        cadre2 =tkinter.LabelFrame(self.fenetre,bg ="gray85",border =3, relief =tkinter.GROOVE,text="Hyper paramètres",width = 400)
        cadre2.grid(row=0, column=1)
        invite0 =tkinter.Label(cadre2, text ='Vitesse d\'apprentissage :', width =20, height =1, fg ="navy")
        invite0.pack()
        self.vitesse_recu =tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.vitesse_recu.set("0.85")  # facultatif: assigne une valeur à la variable
        saisie0 =tkinter.Entry(cadre2,textvariable =self.vitesse_recu, width =10)
        saisie0.pack()
        invite1 =tkinter.Label(cadre2, text ='facteur d\'actualisation :', width =20, height =1, fg ="navy")
        invite1.pack()
        self.facteur_actua_recu=tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.facteur_actua_recu.set("0.99")  # facultatif: assigne une valeur à la variable
        saisie1 =tkinter.Entry(cadre2,textvariable =self.facteur_actua_recu, width =10)
        saisie1.pack()
        invite2 =tkinter.Label(cadre2, text ='facteur d\'exploration :', width =20, height =1, fg ="navy")
        invite2.pack()
        self.facteur_explo_recu=tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.facteur_explo_recu.set("0.1")  # facultatif: assigne une valeur à la variable
        saisie2 =tkinter.Entry(cadre2,textvariable =self.facteur_explo_recu, width =10)
        saisie2.pack()
        invite3 =tkinter.Label(cadre2, text ='durée entre 2 test en s :', width =20, height =1, fg ="navy")
        invite3.pack()
        self.duree_entre_2_tests_recu=tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.duree_entre_2_tests_recu.set("0.5")  # facultatif: assigne une valeur à la variable
        saisie3 =tkinter.Entry(cadre2,textvariable =self.duree_entre_2_tests_recu, width =10)
        saisie3.pack()
        
        #Création de l'espace d'affichage de la Qtable
        self.espace_qtable = tkinter.Canvas(self.fenetre, width = 500, height = 400)
        self.espace_qtable.grid(row = 1, column =0 ) 
        #self.espace_qtable.pack(side=tkinter.LEFT)
        self.espace_qtable.create_text(200, 10, text="valeurs de la qtable",justify = tkinter.LEFT)
        self.valeur_qtable = self.espace_qtable.create_text(260, 240, text="",justify = tkinter.LEFT)
        self.espace_qtable.update()
        
    def affichage_de_la_qtable(self,Q,num_actions,nom_action) :
        chaine_qtable = ""
        for j_ligne in range(4):
            for action in range(num_actions):
                for i_col in range (4):
                    chaine_qtable += nom_action[action]+str(" %3.2f" % Q[(j_ligne*4+i_col),action])+"\t\t"
                chaine_qtable+="\n"
            chaine_qtable+="\n\n"
        self.espace_qtable.itemconfigure(self.valeur_qtable, text=chaine_qtable)
        self.espace_qtable.update()
        
        
    

class espace_de_jeu_apprentissage :
    def __init__(self,fenetre):
        #Création de l'espace de jeu et des acteurs
        self.espace = tkinter.Canvas(fenetre.fenetre, width = 400, height = 400)
        self.espace.grid(row = 1, column =1)
        #self.espace.pack()
        self.espace.create_line(100,0,100,400, fill="gray")
        self.espace.create_line(200,0,200,400, fill="gray")
        self.espace.create_line(300,0,300,400, fill="gray")
        self.espace.create_line(00,100,400,100, fill="gray")
        self.espace.create_line(00,200,400,200, fill="gray")
        self.espace.create_line(00,300,400,300, fill="gray")
        
        self.image_lapin =tkinter.PhotoImage(file ="lapin.png")  # ouverture d'un fichier PNG existant
        largeur_lapin =self.image_lapin.width(); hauteur_lapin =self.image_lapin.height() # détermination des dimensions
        self.lapin =self.espace.create_image(largeur_lapin//2+20, hauteur_lapin//2+1, image =self.image_lapin) # image à centrer
        
        self.image_renard =tkinter.PhotoImage(file ="renard.png")  # ouverture d'un fichier PNG existant
        largeur_renard =self.image_renard.width(); hauteur_renard =self.image_renard.height() # détermination des dimensions
        self.renard =self.espace.create_image(largeur_renard//2+120, hauteur_renard//2+1, image =self.image_renard) # image à centrer
        
        self.image_carotte =tkinter.PhotoImage(file ="carotte.png")  # ouverture d'un fichier PNG existant
        largeur_carotte =self.image_carotte.width(); hauteur_carotte =self.image_carotte.height() # détermination des dimensions
        self.carotte =self.espace.create_image(largeur_carotte//2+220, hauteur_carotte//2+1, image =self.image_carotte) # image à centrer
        
        self.image_bloc =tkinter.PhotoImage(file ="bloc.png")  # ouverture d'un fichier PNG existant
        largeur_bloc =self.image_bloc.width(); hauteur_bloc =self.image_bloc.height() # détermination des dimensions
        self.bloc =self.espace.create_image(largeur_bloc//2+320, hauteur_bloc//2+1, image =self.image_bloc) # image à centrer
        self.espace.update()    
        
