#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jun 22 11:22:42 2022

@author: Anthony Juton
"""

import tkinter
from PIL import Image
from PIL import ImageTk

#Défintion de la classe fenetre apprentissage, gérant affichages et boutons
class fenetre_apprentissage :   
    #fonctions lancées par des événements
    def bouton_callback(self):
        self.start=1
        print("Start")
        
    def bouton2_callback(self):
        self.rejouer=1
        print("Rejouer")
        
    def fonction_affichage(self):
        if self.affichage :
            #on passe ien mode manuel, les boutons passent en rouge
            self.affichage = False
            self.mon_bouton3.configure(bg="red")
            self.mon_bouton3.configure(activebackground="salmon")
        else:
            #on repasse en mode auto, les boutons reprennent la couleur d'origine
            self.affichage = True
            self.mon_bouton3.configure(bg='#d9d9d9')
            self.mon_bouton3.configure(activebackground='#ececec')
    
    def fonction_chgt_piste(self):
        if self.piste_validation :
            #on passe ien mode manuel, les boutons passent en rouge
            self.piste_validation = False
            self.mon_bouton4.configure(bg='#d9d9d9')
            self.mon_bouton4.configure(activebackground='#ececec')
            self.ma_piste_img=tkinter.PhotoImage(file='piste_avec_lignes.png')
            self.espace_dessin.create_image(400,300,image=self.ma_piste_img)
            self.image_piste=Image.open('piste_avec_lignes.png')
        else:
            #on repasse en mode auto, les boutons reprennent la couleur d'origine
            self.piste_validation = True
            self.mon_bouton4.configure(bg="green")
            self.mon_bouton4.configure(activebackground="dark sea green")
            self.ma_piste_img=tkinter.PhotoImage(file='piste3.png')
            self.espace_dessin.create_image(400,300,image=self.ma_piste_img)
            self.image_piste=Image.open('piste3.png')
    
    #Pour déplacer la voiture d'un clic de souris    
    def souris_callback(self,event_souris):
        self.ma_voiture.x = event_souris.x
        self.ma_voiture.y = event_souris.y
        self.ma_voiture.avancer(1)
        print(event_souris.x,event_souris.y)
        self.maj_affichage()
        
    #Pour déplacer la voiture avec les touches flèches du clavier
    #toute autre touche affiche la valeur des capteurs.
    def clavier_callback(self,event_clavier):
        touche=(event_clavier.keysym)
        if touche == 'Up' :
            self.ma_voiture.y-=10.0
            self.ma_voiture.direction=90.0
        elif touche == 'Down' :
            self.ma_voiture.y+=10.0
            self.ma_voiture.direction=270.0
        elif touche == 'Right' :
            self.ma_voiture.x+=10.0
            self.ma_voiture.direction=0.0
        elif touche == 'Left' :
            self.ma_voiture.x-=10.0
            self.ma_voiture.direction=180.0
        # algorithme comportemental
        elif touche == 'A':
            capteurs=self.ma_voiture.lecture_capteurs(self.image_piste)
            self.ma_voiture.direction = self.ma_voiture.direction + (capteurs[0]*50 - capteurs[2]*50)
            vitesse = capteurs[1]*50/2
            self.ma_voiture.avancer(vitesse)
        else :        
            capteurs=self.ma_voiture.lecture_capteurs(self.image_piste)
            print(capteurs)
        self.maj_affichage()
    
    def __init__(self,ma_voiture) : 
        self.start=0
        self.rejouer=0
        self.affichage = True
        self.piste_validation = False
        self.ma_voiture = ma_voiture
        
        #Création de la fenêtre
        self.ma_fenetre = tkinter.Tk()
        self.ma_fenetre.title('Voiture autonome')
        cadre =tkinter.LabelFrame(self.ma_fenetre,bg ="gray85",border =3, relief =tkinter.GROOVE,text="Contrôles", width = 500)
        cadre.grid(row=0, column=0)
        mon_bouton=tkinter.Button(cadre,text='Départ / Arrêt apprentissage',command= self.bouton_callback)
        mon_bouton.pack(side =tkinter.LEFT)
        mon_bouton2=tkinter.Button(cadre,text='Rejouer le meilleur / Arrêter',command= self.bouton2_callback)
        mon_bouton2.pack(side =tkinter.LEFT)
        self.mon_bouton3 = tkinter.Button(cadre, text ="Affichage", command = self.fonction_affichage)
        self.mon_bouton3.pack(side =tkinter.LEFT)
        self.mon_bouton4 = tkinter.Button(cadre, text ="Piste_Validation", command = self.fonction_chgt_piste)
        self.mon_bouton4.pack(side =tkinter.LEFT)
        
        cadre1 =tkinter.LabelFrame(self.ma_fenetre,bg ="gray85",border =3, relief =tkinter.GROOVE,text="Actions manuelles", width = 800)
        cadre1.grid(row=1, column=0)
        texte1 =tkinter.Label(cadre1, text ="Cliquer sur la piste pour y faire apparaître la voiture")
        texte1.pack()
        texte2 =tkinter.Label(cadre1, text ="Utiliser les flèches pour orienter la voiture")
        texte2.pack()
        texte3 =tkinter.Label(cadre1, text ="")
        texte3.pack()
        texte4 =tkinter.Label(cadre1, text ="Utiliser la touche A pour le modèle comportemental")
        texte4.pack()        
        texte5 =tkinter.Label(cadre1, text ="direction = direction + (capteurg-capteurd) et vitesse = capteur_milieu/2")
        texte5.pack()
        texte4 =tkinter.Label(cadre1, text ="")
        texte4.pack()        
        texte5 =tkinter.Label(cadre1, text =" Attention : la vitesse de la voiture issue de l'apprentissage est uniquement liée à la vitesse d'affichage de la machine ")
        texte5.pack()
        
        cadre2 =tkinter.LabelFrame(self.ma_fenetre,bg ="gray85",border =3, relief =tkinter.GROOVE,text="Hyper paramètres",width = 400)
        cadre2.grid(row=0, column=1)        
        #zones de saisie pour les hyperparamètres
        invite0 =tkinter.Label(cadre2, text ='Learning rate :', width =20, height =1, fg ="navy")
        invite0.pack()
        self.learning_rate_recu =tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.learning_rate_recu.set("0.1")  # facultatif: assigne une valeur à la variable
        saisie0 =tkinter.Entry(cadre2,textvariable =self.learning_rate_recu, width =10)
        saisie0.pack()
        invite1 =tkinter.Label(cadre2, text ='facteur d\'actualisation :', width =20, height =1, fg ="navy")
        invite1.pack()
        self.facteur_actua_recu=tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.facteur_actua_recu.set("0.99")  # facultatif: assigne une valeur à la variable
        saisie1 =tkinter.Entry(cadre2,textvariable =self.facteur_actua_recu, width =10)
        saisie1.pack()
        invite2 =tkinter.Label(cadre2, text ='facteur d\'exploration :', width =20, height =1, fg ="navy")
        invite2.pack()
        self.facteur_explo_recu=tkinter.DoubleVar()  # definition d'une variable-chaine pour recevoir la saisie d'un nombre
        self.facteur_explo_recu.set("1.0")  # facultatif: assigne une valeur à la variable
        saisie2 =tkinter.Entry(cadre2,textvariable =self.facteur_explo_recu, width =10)
        saisie2.pack()
        
        self.espace_dessin = tkinter.Canvas(self.ma_fenetre,width=800,height=600,background='#FFFFFF')
        self.espace_dessin.grid(row=2, column=0)
        
        self.ma_piste_img=tkinter.PhotoImage(file='piste_avec_lignes.png')
        self.espace_dessin.create_image(400,300,image=self.ma_piste_img)
        self.image_piste=Image.open('piste_avec_lignes.png')
        
        self.voiture_img=Image.open('voiture_bleue_mini.png')
        self.tkimage_voiture = ImageTk.PhotoImage(self.voiture_img.rotate(self.ma_voiture.direction))
        self.image_v = self.espace_dessin.create_image(self.ma_voiture.x, self.ma_voiture.y, image=self.tkimage_voiture)
        self.espace_dessin.update()
        
        self.espace_dessin.bind("<Button-1>",self.souris_callback)
        self.ma_fenetre.bind("<Key>", self.clavier_callback)

    def maj_affichage(self):
        self.tkimage_voiture = ImageTk.PhotoImage(self.voiture_img.rotate(self.ma_voiture.direction))
        self.espace_dessin.delete(self.image_v)
        self.image_v = self.espace_dessin.create_image(self.ma_voiture.x, self.ma_voiture.y, image=self.tkimage_voiture)
        self.espace_dessin.coords(self.image_v,self.ma_voiture.x, self.ma_voiture.y)
        self.espace_dessin.update()
        