#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jun 22 12:07:10 2022

@author: Anthony Juton
"""
import math
import numpy as np


#définition de la classe voiture, interagissant avec une image_piste
class voiture:
    def __init__(self,xinit,yinit,dirinit):
        self.set_x(xinit)
        self.set_y(yinit)
        self.set_direction(dirinit)
        self.state = 0
        self.reset()
  
    def set_x(self, valeur):
        self.__x=max(min(valeur,800),0)
    
    def get_x(self):
        return(self.__x)
        
    x = property(get_x,set_x)
        
    def set_y(self, valeur):
        self.__y=max(min(valeur,600),0)
    
    def get_y(self):
        return(self.__y)
        
    y = property(get_y,set_y)
    
    def set_direction(self,valeur):
        self.__direction = valeur
    
    def get_direction(self):
        return(self.__direction)
        
    direction = property(get_direction,set_direction)
    
    def get_state(self,image_piste):
        capteurs = self.lecture_capteurs(image_piste)
        #calcul de l'état du système
        self.state = int(capteurs[0]*50*2500+capteurs[1]*50*50+capteurs[2]*50)
        return(self.state)
    
    def avancer(self,vitesse):
        self.x += vitesse*math.cos(self.direction*math.pi/180)
        self.y -= vitesse*math.sin(self.direction*math.pi/180)
    
    def lecture_capteurs(self,image_piste):
        pas_capteur=1
        #capteur central
        xcapt = self.x
        ycapt = self.y
        dir_rad = self.direction * math.pi/180
        while image_piste.getpixel((xcapt, ycapt))[0] == 255 and xcapt > 0 and xcapt < 800 and ycapt > 0 and ycapt < 600 :
            xcapt += pas_capteur*math.cos(dir_rad); 
            ycapt -= pas_capteur*math.sin(dir_rad); 
            #mon_espace_dessin.create_oval(xcapt-1,ycapt-1,xcapt+1,ycapt+1)
        distance_capt_central = min(49,int( ((xcapt-self.x)**2+(ycapt-self.y)**2)**0.5/10))
        #capteur gauche
        xcapt = self.x
        ycapt = self.y
        dir_rad = (self.direction+45) * math.pi/180 
        while image_piste.getpixel((xcapt, ycapt))[0] == 255 and xcapt > 0 and xcapt < 800 and ycapt > 0 and ycapt < 600 :
            xcapt += pas_capteur*math.cos(dir_rad); 
            ycapt -= pas_capteur*math.sin(dir_rad); 
            #mon_espace_dessin.create_oval(xcapt-1,ycapt-1,xcapt+1,ycapt+1)
        distance_capt_gauche = min(49,int(((xcapt-self.x)**2+(ycapt-self.y)**2)**0.5/10))
        #capteur droit
        xcapt = self.x
        ycapt = self.y
        dir_rad = (self.direction-45) * math.pi/180 
        while image_piste.getpixel((xcapt, ycapt))[0] == 255 and xcapt > 0 and xcapt < 800 and ycapt > 0 and ycapt < 600 :
            xcapt += pas_capteur*math.cos(dir_rad)
            ycapt -= pas_capteur*math.sin(dir_rad)
            #mon_espace_dessin.create_oval(xcapt-1,ycapt-1,xcapt+1,ycapt+1)
        distance_capt_droite = min(49,int(((xcapt-self.x)**2+(ycapt-self.y)**2)**0.5/10))
        #La division par 50 permet d'avoir des valeurs entre 0 et 1 plus facile d'utilisation pour l'apprentissage
        return (distance_capt_gauche/50, distance_capt_central/50, distance_capt_droite/50)
    
    def step(self,action,image_piste):
        nom_action=(-3,0,+3)
        self.direction = self.direction + nom_action[action]
        self.avancer(1)        
        capteurs = self.lecture_capteurs(image_piste)
        #calcul de l'état du système
        self.state = capteurs[0]*2500+capteurs[1]*50+capteurs[2]
        #valeur si aucun passage de balise ou aucun mur
        reward = 0
        done = False
        if(capteurs[1]<=4/50) :
            reward = -1000
            done = True
        #passage de la première balise
        elif(self.x>600 and self.x<610 and self.y<150):
            if( self.balise1 == False and self.balise7 == True):
                self.balise1 = True
                self.balise6 = False
                reward = +100
                print("balise 1")
                done = False
            if(self.balise2 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        #passage de la seconde balise
        elif(self.x>600 and self.y>200 and self.y<210):
            if(self.balise2 == False and self.balise1 == True):
                self.balise2 = True
                self.balise7 = False
                reward = +100
                print("balise 1 et 2")
                done = False
            if(self.balise3 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        #passage de la troisième balise
        elif(self.x<600 and self.x>590 and self.y>250 and self.y<350):
            if(self.balise3 == False and self.balise2 == True):
                self.balise3 = True
                self.balise1 = False
                reward = +100
                print("balise 1, 2 et 3")
                done = False
            if(self.balise4 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        #passage de la quatrième balise
        elif(self.x<470 and self.x>300 and self.y>350 and self.y<360):
            if(self.balise4 == False and self.balise3 == True ):
                self.balise4 = True
                self.balise2 = False
                reward = +100
                print("balise 1, 2, 3 et 4")
                done = False
            if(self.balise5 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        #passage de la cinquième balise
        elif(self.x<300 and self.x>290 and self.y>430):
            if(self.balise5 == False and self.balise4 == True ):
                self.balise5 = True
                self.balise3 = False
                reward = +100            
                print("balise 1, 2, 3, 4 et 5")
                done = False
            if(self.balise6 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        #passage de la sixième balise
        elif(self.x<200 and self.y>420 and self.y<430):
            if(self.balise6 == False and self.balise5 == True ):
                self.balise6 = True
                self.balise4 = False
                reward = +100
                print("balise 1, 2, 3, 4, 5 et 6")
                done = False
            if(self.balise7 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        #passage de la septième balise
        elif(self.x>200 and self.x<210 and self.y<150):
            if(self.balise7 == False and self.balise6 == True ):
                self.balise7 = True
                self.balise5 = False
                reward = +100
                print("balise 1, 2, 3, 4, 5, 6 et 7")
                done = False
            if(self.balise1 == True) :
                reward = -1000
                print("sens inverse")
                done = True
        elif(self.cumul_reward>10000) :
            reward = +100
            done = True
        self.cumul_reward+=reward
        return capteurs, reward, done, 0
    
    def reset(self):
        self.x = 300+np.random.randint(-100,+100)
        self.y = 85+np.random.randint(-25,+25)
        self.direction = np.random.randint(-25,+25)
        self.cumul_reward = 0
        self.balise7 = True
        self.balise6 = False
        self.balise5 = False
        self.balise4 = False
        self.balise3= False
        self.balise2 = False
        self.balise1 = False