#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri May 28 15:34:30 2021

@author: ajuton
"""

import random
import numpy as np
import time
from Voiture_autonome_2022_fenetre_v2 import fenetre_apprentissage
from Voiture_autonome_2022_voiture_v2 import voiture

ma_voiture = voiture(200,100,10)
fenetre=fenetre_apprentissage(ma_voiture)
fenetre.ma_fenetre.title('Voiture autonome - Apprentissage par renforcement Q-learning')
fenetre.maj_affichage()


states_n = 125000
actions_n = 3
num_episodes = 10000
Q = np.random.rand(states_n, actions_n)/100.0 #initialisation de Q avec de faibles valeurs
Qbest = np.zeros([states_n, actions_n])#pour stocker la meilleure table
cumul_reward_list = []
actions_list = []
states_list = []
time.sleep(1.0)
best_total_reward = 0

# Set learning parameters
fenetre.learning_rate_recu.set(0.25) #vitesse d'apprentissage learning rate .85
fenetre.facteur_actua_recu.set(0.85) #facteur d'actualisation .99
fenetre.facteur_explo_recu.set(1.0) #facteur d'exploration 1 par défaut
num_actions=3

while(True):
    fenetre.espace_dessin.update()
    
    if fenetre.start : #appui sur le bouton depart apprentissage
        fenetre.start= False

        tdepart=time.time()
        
        for i in range(num_episodes):
            if(fenetre.start):
                fenetre.start= False
                break
            actions = []
            ma_voiture.reset()
            capteurs = ma_voiture.lecture_capteurs(fenetre.image_piste)
            s = ma_voiture.get_state(fenetre.image_piste)
            states = [s]
            cumul_reward = 0
            fin_du_jeu = False
            fenetre.maj_affichage()
            
        #   initialisation de l'espace d'affichage d'éléments de la Q table
            
           # time.sleep(0.2)
            while True:
                #Mise à jour des hyper-paramètres avec les valeurs indiquées par les boutons
                lr=float(fenetre.learning_rate_recu.get()) #vitesse d'apprentissage learning rate
                y=float(fenetre.facteur_actua_recu.get()) #facteur d'actualisation 
                facteur_explo=float(fenetre.facteur_explo_recu.get()) #facteur d'exploration 1 par défaut
                
                # on choisit une action aléatoire avec une certaine probabilité, qui décroît petit à petit
                #ou on choisit l'action permettant d'espérer la meilleure récompense
                if random.random() < facteur_explo*(1. / (i/100+1)) : #décroissance à régler 
                    a = random.randint(0,num_actions-1)
                else :
                    a = np.argmax(Q[s,:])
                
                #j'applique l'action et je calcule la récompense
                capteurs ,reward,fin_du_jeu,_ = ma_voiture.step(a,fenetre.image_piste)
                s1 = ma_voiture.get_state(fenetre.image_piste)
         
                Q[s, a] = Q[s, a] + lr*(reward + y * np.max(Q[s1,:]) - Q[s, a]) # Fonction de mise à jour de la Q-table
                cumul_reward += reward
                s = s1
                actions.append(a)
                states.append(s)
                if fenetre.affichage :
                    fenetre.maj_affichage()
                if fin_du_jeu == True:
                    if cumul_reward > best_total_reward:
                        best_total_reward=cumul_reward
                        Qbest = np.copy(Q)
                    break
                
            states_list.append(states)
            actions_list.append(actions)
            cumul_reward_list.append(cumul_reward)
    
        tfin = time.time()
        print("duree de l'essai : " +str(tfin-tdepart) + "secondes")
        print("Meilleure récompense cumulée : " +  str(best_total_reward))
        
    if fenetre.rejouer :        
        fenetre.rejouer=False
            
        while(True): #tant qu'il n'y a pas d'accident
            s = ma_voiture.get_state(fenetre.image_piste)
            a = np.argmax(Qbest[s,:])
            capteurs ,_,_,_ = ma_voiture.step(a,fenetre.image_piste)
            fenetre.maj_affichage()
            if(capteurs[1]<0.02) : #en cas d'accident on arrête la simulation
                break
            if fenetre.start == True :
                fenetre.start = False
                break
            if fenetre.rejouer :
                fenetre.rejouer= False
                break

fenetre.ma_fenetre.mainloop()

